ADDON_NAME = "GreatestRogueOnTheServer";
ADDON_PREFIX = "grots";
ADDON_COMMAND_PREFIX = "grots-";
ADDON_MSGDELIM = "~";


grots = CreateFrame("Frame");
grots.EventManager = CreateFrame("Frame");
grots.debug = false;
grots.testing = false; -- remember to take the "beta" stuff off in the toc
grots.fully_loaded = false;
grots.version = "1.3.1"; -- make sure this is changed in the toc as well
grots.me = UnitName("player");
grots.options = {
    last_sent_request = 0,
    last_recd_request = 0,
    throttle_s = 120,
    masters = {"Stankybutt","Buttfarter","Kylewilde","Buttkiss"},
    messages = {
                "Stankybutt is the greatest rogue on the server!",
                "All hail Stankybutt, the greatest rogue on the server!",
                "Have you heard of our lord and saviour, Stankybutt?  He's the greatest rogue on the server",
                "Stankybutt, the greatest rogue on the server, and his legendary Gutgores are #1!",
                "Stankybutt, the greatest rogue on the server, is the greatest rogue on the server",
                "There can only be one greatest rogue on the server, all hail Stankybutt",
                "Did you ever hear of that rogue that parsed pink with dual Gutgores? I heard his name was Stankybutt, of Blackwater - the greatest rogue on the server!",
                "Chuck Norris endorses Stankybutt for best rogue on the server!",
                "Stankybutt2020!",
                "And on the 7th day, God created Stankybutt. Then God smiled.",
                "And on that day Noah did not have room for Stankybutt on his boat, for he was too much of an animal for it to handle",
                "Sure, being a Scarab Lord is cool and all. But there's only one Stankybutt - the greatest rogue on the server!",
                "Did you know that Stankybutt, the greatest rogue on the server, used to be the final boss in AQ40? It was mathematically impossible win against him, so they swapped to C'Thun",
                "Stankybutt once took out an entire horde raid with only his Gutgore Rippers! Amazing!",
                "Stankybutt is #1! One could even call him the greatest rogue on the server!"
            },
    slave_no = {
                "No? May Stankybutt, the greatest rogue on the server, forgive you.",
                "No? Lets hope Stankybutt doesn't find out!",
                "No? You won't go far if you don't recognize Stankybutt, the greatest rogue on the server.",
                "No? Why won't you help spread the word of the greatest rogue on the server, Stankybutt?!",
                "No? I'm sure you've made the greatest rogue on the server, Stankybutt, very sad."
    },
    colours = {
        ["druid"] = { r = 1, g = 0.49, b = 0.04, hex = "FF7D0A" },
        ["hunter"] = {  r = 0.67, g = 0.83, b = 0.45, hex = "ABD473" },
        ["mage"] = { r = 0.25, g = 0.78, b = 0.92, hex = "40C7EB" },
        ["priest"] = { r = 1, g = 1, b = 1, hex = "FFFFFF" },
        ["rogue"] = { r = 1, g = 0.96, b = 0.41, hex = "FFF569" },
        ["shaman"] = { r = 0.96, g = 0.55, b = 0.73, hex = "F58CBA" },
        ["paladin"] = { r = 0.96, g = 0.55, b = 0.73, hex = "F58CBA" },
        ["warlock"] = { r = 0.53, g = 0.53, b = 0.93, hex = "8787ED" },
        ["warrior"] = { r = 0.78, g = 0.61, b = 0.43, hex = "C79C6E" },
        ["offline"] = { r = 1, g = 0, b = 0, hex = "FF0000" },
        ["drinking"] = {r=0.06,g=0.14,b=1,hex="3F91CC"},
        ["red"] = { r = 1, g = 0, b = 0, hex = "FF0000" },
        ["green"] = { r = 1, g = 0, b = 0, hex = "00FF00" },
        ["yellow"] = { r = 1, g = 0, b = 0, hex = "FFFF00" }
    },
    raid = {current = {}, numInGroup = {}}
};
-- Commands send to\from users should be grots-{command}-{scope}~[args1]~[arg..n]
grots.usercommands = {
    ["announce"] = {
        ["helpdesc"] = "Requests everyone announce his greatness",
        ["testing"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-testing", ["chattype"] = "WHISPER", ["paramsreq"] = true},
        ["guild"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-guild", ["chattype"] = "GUILD", ["helpdesc"] = "Announces to guild chat", ["paramsreq"] = false},
        ["party"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-party", ["chattype"] = "PARTY", ["helpdesc"] = "Announces to party chat", ["paramsreq"] = false},
        ["raid"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-raid", ["chattype"] = "RAID", ["helpdesc"] = "Announces to the raid", ["paramsreq"] = false},
        ["person"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-person", ["chattype"] = "WHISPER", ["helpdesc"] = "Announces to a person, specify who", ["paramsreq"] = true},
        ["player"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-player", ["chattype"] = "WHISPER", ["helpdesc"] = "Announces to a person, specify who", ["paramsreq"] = true},
        ["channel"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-channel", ["chattype"] = "CHANNEL", ["helpdesc"] = "Announces to a channel, specify which one", ["paramsreq"] = true},
        ["say"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-say", ["chattype"] = "SAY", ["helpdesc"] = "Announces it as a /say", ["paramsreq"] = false},
        ["yell"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-yell",  ["chattype"] = "YELL", ["helpdesc"] = "Announces it as a /yell", ["paramsreq"] = false},
        ["officer"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-officer",  ["chattype"] = "OFFICER", ["helpdesc"] = "Announces to o-chat", ["paramsreq"] = false}
    },
    ["who"] = {["command"] = {["request"] = ADDON_COMMAND_PREFIX.."who-req", ["response"] = ADDON_COMMAND_PREFIX.."who-rsp"}, ["helpdesc"] = "Checkes who currently uses the addon"},
    ["list"] = {
        ["helpdesc"] = "Lists all players in party / raid into a copyable dialog.  Can be further filtered",
        ["class"] = {["helpdesc"] = "Lists all players in the raid plus their class", ["fn"]="ListPlayers_class"},
        ["healer"] = {["helpdesc"] = "Lists all healers and their mana status'", ["fn"]="ListPlayers_healer"}
    },
    ["buffs"] = {["helpdesc"] = "Checks current raid for Ony and DM Tribute buffs (addon not required)"},
    ["sort"] = {
        ["helpdesc"] = "(beta) Reorders the raid based on the passed option or a custom string <name1>:<group1>&<name..n>:<group..i>&",
        ["cthun"] = {["helpdesc"] = "By C'Thun Groupings", ["fn"]="SortRaid_cthun"}
    }
}

-- Events
function grots.OnReady()
    grots.dbgmsg("Entering grots.OnReady()");
    if (grots.testing) then
        grots.msg("## Testing mode ##")
        table.insert(grots.options.masters,"Dedbeartank");
        table.insert(grots.options.masters,"Priestly");
        table.insert(grots.options.masters,"Lilpink");
        grots.options.throttle_s = 10;
    end
    if (grots.isMaster(UnitName("player"))) then
        grots.msg("Loaded v"..grots.version.." and ready, master");
    else
        grots.msg("Loaded v"..grots.version.." and ready to serve the all powerful, and greatest rogue on the server, Stankybutt");
    end
    grots.dbgmsg("Exiting grots.OnReady()");
end

function grots.OnEvent(frame, event, ...)
    grots.dbgmsg("Entering grots.OnEvent()");

	if (event == 'ADDON_LOADED') then
        local name = ...;
        grots.dbgmsg("grots name: "..name);
        if name == ADDON_NAME then
            grots.dbgmsg("grots is now ready");
			grots.OnReady();
        end
		return;
	end

	if (event == 'PLAYER_LOGIN') then
        grots.fully_loaded = true;
        C_ChatInfo.RegisterAddonMessagePrefix(ADDON_PREFIX);
        grots.dbgmsg("Exiting grots.OnEvent() - PLAYER_LOGIN");
		return;
	end

	if (event == 'CHAT_MSG_ADDON') then
        grots.OnAddonMsg(...);
        grots.dbgmsg("Exiting grots.OnEvent() - CHAT_MSG_ADDON");
		return;
    end
    
    grots.dbgmsg("Exiting grots.OnEvent() - No caught event");
end

-- Master Functions
function grots.AnnounceToClients(args)
    grots.dbgmsg("Entering grots.AnnounceToClients()");
    local scope = args[1]
    local destinations = args[2]

    -- check for spamming
    local isthrot,timeleft = grots.isThrottled(grots.options.last_sent_request)
    if (isthrot) then 
        grots.msg("Too many requests, please wait another "..timeleft.." seconds and try again")
        grots.dbgmsg("Exiting grots.SendToClients() - Throttled");
        return;
    end

    -- make sure the person sending is master
    if (not grots.isMaster(UnitName("player"))) then
        grots.msg("LMAO, you wish you were Stankybutt. Git gud.");
        grots.dbgmsg("Exiting grots.SendToClients() - Not master");
        return;
    end

    -- make sure it's a valid scope
    if (grots.usercommands.announce[scope] == nil) then
        grots.msg("Couldn't find the scope passed.");
        grots.dbgmsg("Exiting grots.AnnounceToClients() - 1 no scope");
        return;
    end

    -- make sure that a parameter is passed, if needed
    if (grots.usercommands.announce[scope].paramsreq and destinations == nil) then
        grots.msg("Destination required for "..scope.." announcements");
        return;
    end

    if (scope == "testing") then
        if (destinations ~= nil) then
            C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.buildCommand(grots.usercommands.announce[scope].command,destinations), "WHISPER", "Magely");
        else
            grots.msg("Missing person");
            grots.dbgmsg("Exiting grots.AnnounceToClients() - testing - no destination");
            return;
        end
    elseif (IsInGuild()) then
        if (grots.usercommands.announce[scope] ~= nil) then
            if (destinations ~= nil) then
                C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.buildCommand(grots.usercommands.announce[scope].command,destinations), "GUILD");
            else
                C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.usercommands.announce[scope].command, "GUILD");
            end
        else
            grots.msg("Couldn't find the scope passed.");
            grots.dbgmsg("Exiting grots.AnnounceToClients() - 2 no scope");
            return;
        end
    else
        grots.msg("Your character needs to be in a guild");
        grots.dbgmsg("Exiting grots.AnnounceToClients() - no guild");
        return;
    end
    grots.msg("OK Senpai, sending announcement request to all slaves");
    grots.options.last_sent_request = time();

    grots.dbgmsg("Exiting grots.AnnounceToClients()");
end

-- Slave Functions
-- Addon Message Event Handler
function grots.OnAddonMsg(prefix, msg, dist, sender)
    grots.dbgmsg("Entering grots.OnAddonMsg()");
    grots.dbgmsg("prefix: '"..prefix.."' msg: '"..msg.."' dist: '"..dist.."' sender: '"..sender.."'");

    -- make sure it's from grots
    if (prefix ~= ADDON_PREFIX) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - not grots");
        return;
    end

    -- ignore our own messages, unless testing is enabled
    if (grots.testing == false and string.find(sender,UnitName("player")) ~= nil) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - ignoring own msg")
        return;
    end    

    -- parse the message
    local suc, cmd = grots.parseCommand(msg);

    -- make sure it was successful
    if (not suc) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - msg parse failure");
        return;
    end

    cmd["sender"] = sender;
    cmd["distribution"] = dist;
    -- make sure it's a valid grots command
    if (grots.usercommands[cmd.command] == nil) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - Invalid grots command")
        return;
    end

    if (cmd.command == "announce") then
        grots.handleAnnounce(cmd)
    elseif (cmd.command == "who") then
        grots.handleWho(cmd);
    end

    grots.dbgmsg("Exiting grots.OnAddonMsg()");
end

function grots.handleAnnounce(cmd)
    grots.dbgmsg("Entering grots.handleAnnounce()");
    
    -- make sure it's from the master
    if (not grots.isMaster(cmd.sender)) then
        grots.dbgmsg("Exiting grots.handleAnnounce() - sender not master");
        return;
    end
    -- make sure we're not getting spammed
    if (grots.isThrottled(grots.options.last_recd_request)) then
        grots.dbgmsg("Exiting grots.handleAnnounce() - throttled");
        return;
    end

    if (grots.usercommands.announce[cmd.scope].paramsreq and cmd.args[1] == nil) then
        grots.dbgmsg("Exiting grots.handleAnnounce() - Parameteres requred, but not passed.")
        return;
    end

    grots.msg("Stankybutt has requested we announce his greatness, will you comply?");
    grots.options.last_recd_request = time();

    grots.dbgmsg("Firing confirmation dialog for the end user");
    local loc = cmd.scope;
    if (cmd.args[1] ~= nil) then
        loc = loc .. " - "..cmd.args[1];
    end
    local confdlg = StaticPopup_Show("GROTS_CONFIRM_SEND_MESSAGE", loc);
    if (confdlg) then
        confdlg.data = cmd;
    end
    grots.dbgmsg("Exiting grots.handleAnnounce()");
end


-- Commands send to\from users should be grots-{command}-{scope}~[args1]~[arg..n]
-- ~ = msg delim
function grots.parseCommand(msg)
    grots.dbgmsg("Entering grots.parseCommand()");
    grots.dbgmsg("Using: "..ADDON_MSGDELIM.." and "..ADDON_COMMAND_PREFIX.." against msg: "..msg);    

    local args = grots.aSplit(msg,ADDON_MSGDELIM);
    local cmds = grots.aSplit(table.remove(args,1), "-")
    if (cmds[1] == "grots") then
        table.remove(cmds,1);
    end

    local cmdobj = {
        ["command"] = cmds[1],
        ["scope"] = cmds[2],
        ["args"] = args
    };

    grots.dbgmsg("Exiting grots.parseCommand()");
    return true, cmdobj;
end


-- Announcement functions
function grots.executeAnnouncement(cmd)
    grots.dbgmsg("Entering grots.executeAnnouncement()");

    -- double check it's an announcement
    if (cmd.command ~= "announce") then
        grots.dbgmsg("Exiting grots.executeAnnouncement() - Not an announcement");
        return;
    end

    if (grots.usercommands.announce[cmd.scope] ~= nil) then
        if (cmd.scope == "channel") then
            if (cmd.args[1] ~= nil) then
                grots.SendToChannel(grots.options.messages[math.random(1,table.getn(grots.options.messages))], cmd.args[1]);
            else
                grots.dbgmsg("Exiting grots.executeAnnouncement() - no channel");
            end
        elseif (cmd.scope == "person" or cmd.scope== "player") then
            if (cmd.args[1] ~= nil) then
                grots.SendToPerson(grots.options.messages[math.random(1,table.getn(grots.options.messages))], cmd.args[1]);
            else
                grots.dbgmsg("Exiting grots.executeAnnouncement() - no person");
            end
        elseif (cmd.scope == "testing") then
            grots.SendGeneral(grots.options.messages[math.random(1,table.getn(grots.options.messages))], "SAY");
        else
            grots.SendGeneral(grots.options.messages[math.random(1,table.getn(grots.options.messages))], grots.usercommands.announce[cmd.scope].chattype);
        end
    else
        grots.dbgmsg("No scope passed scope");
    end

    grots.dbgmsg("Exiting grots.executeAnnouncement()");
end
function grots.SendGeneral(msg, chattype)
    grots.dbgmsg("Entering grots.SendGeneral()");
    SendChatMessage(msg, chattype);
    grots.dbgmsg("Exiting grots.SendGeneral()");
end
function grots.SendToPerson(msg, person)
    grots.dbgmsg("Entering grots.SendToPerson()");
    SendChatMessage(msg, "WHISPER", nil, person);
    grots.dbgmsg("Exiting grots.SendToPerson()");
end
function grots.SendToChannel(msg, channel)
    grots.dbgmsg("Entering grots.SendToChannel()");

    local index = GetChannelName(channel)
    if (index~=nil) then 
        SendChatMessage(msg , "CHANNEL", nil, index);
    end
    
    grots.dbgmsg("Exiting grots.SendToChannel()");
end

-- Who functions
function grots.PollClients()
    grots.dbgmsg("Entering grots.PollClients()");
    grots.msg("Sending who request")
    C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.usercommands.who.command.request, "GUILD");
    grots.dbgmsg("Exiting grots.PollClients()");
end
function grots.handleWho(cmd)
    if (cmd.scope == "req") then
        C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.usercommands.who.command.response, "WHISPER", cmd.sender);
    else
        grots.msg("Received response from: "..cmd.sender);
    end
end

-- Buff check functions
function grots.CheckForBuffs()
    grots.dbgmsg("Entering grots.CheckForBuffs()");
    local buffedraiders={}
    local ony_name = "Rallying Cry of the Dragonslayer"
    local dm_names ={"Mol'dar's Moxie","Fengus' Ferocity","Slip'kik's Savvy"}
    local zg_name = "Spirit of Zandalar";
    local song_name = "Songflower Seranade";
    local war_name = "Warchief's Blessing";
    local ony_bonus=1
    local dm_bonus=1
    local zg_bonus=1
    local song_bonus=1
    local war_bonus=1

    local pfx = grots.getRaidOrPartyPrefix();
    if grots.testing then
        -- generate testing data
        for r=1,math.random(20,40) do
            local o=math.random(1,2) > 1;
            local z=math.random(1,2) > 1;
            local d=math.random(1,2) > 1;
            local s=math.random(1,2) > 1;
            local w=math.random(1,2) > 1;
            local b=0
            local buffs={}
            if o then
                b=b+ony_bonus
                table.insert(buffs,"Ony/Nef (#)")
            end
            if z then
                b=b+zg_bonus
                table.insert(buffs,"ZG (#)")
            end
            if d then
                b=b+dm_bonus
                table.insert(buffs, math.random(1,3).."/3 DM (#)")
            end
            if s then
                b=b+song_bonus
                table.insert(buffs, "Songflower (#)")
            end
            if w then
                b=b+war_bonus
                table.insert(buffs, "Warchief (#)");
            end
            if o or z or d or s or w then
                --table.insert(buffedraiders,string.format("+%d : %s%s_PlayerName ---- %s",b,string.char(math.random(97,122)),string.char(math.random(97,122)),table.concat(buffs, ", ")))
                local cap = ""
                if b > 3 then
                    b = 3;
                    cap = " (Capped at +3)";
                end
                table.insert(buffedraiders,string.format("+%d : %s ---- %s%s",b,"raidername",table.concat(buffs, ", "),cap))
                --table.insert(buffedraiders,string.format("+%d : %s ---- %s",b,"raidername",table.concat(buffs, ", ")))
            end
        end

        -- so we don't have to join a party\raid
        if pfx == nil then
            pfx = {["count"]=1,["prefix"]="party"}
        end
    elseif pfx == nil then
        grots.msg("Not in party or raid");
        return;
    end

    for raideridx=1,pfx.count do
        local buffs = {}
        local raider = GetRaidRosterInfo(raideridx)
        local dmbuffcount = 0
        local bonus=0

        if raider == nil then
            grots.dbgmsg("Nil raider encountered, breaking iteration");
            break;
        end

        local unitid = pfx.prefix..raideridx;
        if raider == grots.me then
            unitid="player";
        end

        for buffidx=1,40 do
            grots.dbgmsg("Checking "..raider.." @ unitid: "..unitid.." for buffidx: "..buffidx)
            local buffname=UnitBuff(unitid,buffidx)
            if buffname == nil then
                grots.dbgmsg("Nil buffname encountered, breaking iteration");
                break;
            end
            
            grots.dbgmsg("Buffname: "..buffname)
            if buffname==ony_name then
                print(raider.." has "..buffname)
                bonus = bonus + ony_bonus
                table.insert(buffs,"Ony/Nef ("..ony_bonus..")")
            elseif buffname==zg_name then
                print(raider.." has "..buffname)
                bonus = bonus + zg_bonus
                table.insert(buffs,"ZG ("..zg_bonus..")")
            elseif buffname==song_name then
                print(raider.." has "..buffname)
                bonus = bonus + song_bonus
                table.insert(buffs,"Songflower ("..song_bonus..")")
            elseif buffname==war_name then
                print(raider.." has "..buffname)
                bonus = bonus + war_bonus
                table.insert(buffs,"Warchief ("..war_bonus..")")
            else
                for idx,val in pairs(dm_names) do
                    if buffname==val then
                        dmbuffcount = dmbuffcount + 1
                        print(raider.." has "..buffname)
                    end
                end
            end
        end

        if (dmbuffcount > 0) then
            table.insert(buffs, dmbuffcount.."/3 DM ("..dm_bonus..")")
            bonus = bonus + dm_bonus
        end
        if table.getn(buffs) > 0 then
            local cap = ""
            if bonus > 3 then
                bonus = 3;
                cap = " (Capped at +3)";
            end
            table.insert(buffedraiders,string.format("+%d : %s ---- %s%s",bonus,raider,table.concat(buffs, ", "),cap))
            -- table.insert(buffedraiders,raider.." ---- has "..table.concat(buffs, " + ").." = "..bonus)
        end
    end
    
    if table.getn(buffedraiders) > 0 then
        table.sort(buffedraiders);
        grots.showEditableBox(table.concat(buffedraiders,"\r\n"))
    else
        grots.msg("No one has Ony/Nef, DM, or ZG buffs")
    end
    grots.dbgmsg("Exiting grots.CheckForBuffs()");
end
function grots.CheckForBuffs2()
    local bufflist = {
        ["Ony\\Nef"] = {name = "Rallying Cry of the Dragonslayer", value=1},
        ["DM"] = {name = {"Mol'dar's Moxie","Fengus' Ferocity","Slip'kik's Savvy"}, value=1},
        ["ZG"] = {name = "Spirit of Zandalar", value=1},
        ["Songflower"] = {name = "Songflower Seranade", value=1},
        ["Warchief"] = {name = "Warchief's Blessing", value=1},
        ["HunterOny"] = {name = "TESTING-HunterOnlyBuff", value=1, classlist={"Hunter"}}}
    local maxbonus = 3;
    local pfx = grots.getRaidOrPartyPrefix();
    local buffedraiders = {}
    
    if grots.testing then
        -- generate testing data
        for r=1,math.random(20,40) do
            local buffs = {}
            local bonus = 0
            local myclass = {"Hunter","Priest","Rogue","Paladin","Warlock","Mage","Warrior","Druid"}
            local class = myclass[math.random(1,table.getn(myclass))];
            local raider = string.format("%s_%d_name",class,r);
            for buff,vals in pairs(bufflist) do
                local validclass = true;
                if (vals.classlist) then
                    validclass = grots.tableContains(vals.classlist, class)
                end

                if validclass then
                    if type(vals.name) == "table" then
                        if math.random(1,2) > 1 then
                            table.insert(buffs,string.format("%d/%d %s (%d)",math.random(1,table.getn(vals.name)),table.getn(vals.name),buff,vals.value))
                            bonus = bonus + vals.value;
                        end
                    else
                        if math.random(1,2) > 1 then
                            table.insert(buffs, string.format("%s (%d)",buff,vals.value));
                            bonus = bonus + vals.value;
                        end
                    end
                end
            end
            if table.getn(buffs) > 0 then
                local cap = ""
                
                if bonus > maxbonus then
                    cap = string.format(" (Capped at %d)",maxbonus)
                    bonus = maxbonus
                end
    
                table.insert(buffedraiders,string.format("+%d : %s ---- %s%s",bonus,raider,table.concat(buffs, ", "),cap))
            end
        end

        -- so we don't have to join a party\raid
        if pfx == nil then
            pfx = {["count"]=1,["prefix"]="party"}
        end
    elseif pfx == nil then
        grots.msg("Not in party or raid");
        return;
    end

    for raideridx=1,pfx.count do
        local buffs = {}
        local bonus = 0
        local raider, _, _, _, class, _, _, online = GetRaidRosterInfo(raideridx)
        local unitid = pfx.prefix..raideridx
        if raider == grots.me then
            unitid = "player";
        elseif raider == nil then
            break;
        end

        for buff, vals in pairs(bufflist) do
            local validclass = true;
            if (vals.classlist) then
                validclass = grots.tableContains(vals.classlist, class);
            end

            if validclass then
                if type(vals.name) == "table" then
                    local tcount = 0;
                    for bidx=1,table.getn(vals.name) do
                        if grots.unitHasBuff(unitid, vals.name[bidx]) then
                            tcount = tcount+1
                            print(string.format("%s has %s",raider,vals.name[bidx]))
                        end
                    end
                    if tcount > 0 then
                        table.insert(buffs,string.format("%d/%d %s (%d)",tcount,table.getn(vals.name),buff,vals.value))
                        bonus = bonus + vals.value;
                    end
                else
                    if grots.unitHasBuff(unitid, vals.name) then
                        table.insert(buffs,string.format("%s (%d)",buff,vals.value))
                        bonus = bonus + vals.value;
                        print(string.format("%s has %s",raider,vals.name))
                    end
                end
            end
        end

        if table.getn(buffs) > 0 then
            local cap = ""
            
            if bonus > maxbonus then
                cap = string.format(" (Capped at %d)",maxbonus)
                bonus = maxbonus
            end

            table.insert(buffedraiders,string.format("+%d : %s ---- %s%s",bonus,raider,table.concat(buffs, ", "),cap))
        end
    end

    if table.getn(buffedraiders) > 0 then
        table.sort(buffedraiders);
        grots.showEditableBox(table.concat(buffedraiders,"\r\n"))
    else
        grots.msg(string.format("No one has any of the %d buffs",table.getn(bufflist)));
    end
end

-- Player list functions
function grots.ListPlayers(args)
    grots.dbgmsg("Entering grots.ListPlayers()");
    if grots.usercommands.list[args[1]] ~= nil then
        grots[grots.usercommands.list[args[1]].fn]()
    else
        grots.ListPlayers_basic();
    end
    grots.dbgmsg("Exiting grots.ListPlayers()");
end
function grots.ListPlayers_basic()
    grots.dbgmsg("Entering grots.ListPlayers_basic()");
    local raiders={}
    local pfx = grots.getRaidOrPartyPrefix()
    if pfx == nil then
        grots.msg("Not in party or raid");
        return;
    end

    for raideridx=1,pfx.count do
        local raider, _, _, _, class, _, _, online = GetRaidRosterInfo(raideridx)
        if not online then
            table.insert(raiders, "|cFFFF0000"..raider.."|r")
        else
            table.insert(raiders, raider)
        end
    end
    
    if table.getn(raiders) > 0 then
        grots.showEditableBox(table.concat(raiders,"\r\n"))
    end
    grots.dbgmsg("Exiting grots.ListPlayers_basic()");
end
function grots.ListPlayers_class()
    grots.dbgmsg("Entering grots.ListPlayers_class()");
    local raiders={}
    local numgrp = GetNumGroupMembers()
    local pfx = grots.getRaidOrPartyPrefix()

    if pfx == nil then
        grots.msg("Not in party or raid");
        return;
    end

    for raideridx=1,pfx.count do
        local raider, _, _, _, class, _, _, online = GetRaidRosterInfo(raideridx)
        if not online then
            table.insert(raiders, grots.colourTextForClass("offline",raider.."\t")..grots.colourTextForClass(class,class))
        else
            table.insert(raiders, grots.colourTextForClass(class,raider.."\t"..class))
        end
    end
    
    if table.getn(raiders) > 0 then
        grots.showEditableBox(table.concat(raiders,"\r\n"))
    end

    grots.dbgmsg("Exiting grots.ListPlayers_class()");
end
function grots.ListPlayers_healer()
    grots.dbgmsg("Entering grots.ListPlayers_healer()");
    local healers={
        ["Priest"]={totalcurrent=0, totalmax=0,players={}, healname="Flash Heal", healcost=380},
        ["Paladin"] = {totalcurrent=0, totalmax=0,players={}, healname="Flash of Light", healcost=140},
        ["Druid"]={totalcurrent=0, totalmax=0,players={}, healname="Regrowth", healcost=510}}
    local pfx = grots.getRaidOrPartyPrefix()
    local hasHealers = false

    if grots.testing then
        hasHealers = true
        -- add a random amount of each healing class with random cur\max\online\drink values
        for class,val in pairs(healers) do
            for r=1,math.random(1,5) do
                local d=math.random(1,2) > 1
                local o=math.random(1,2) > 1
                table.insert(val.players, {name="PlayerName",current=math.random(1,10000),max=math.random(10000,20000),isonline=o,isdrinking=d});
            end
            for i in pairs(val.players) do
                val.totalcurrent = val.totalcurrent + val.players[i].current;
                val.totalmax = val.totalmax + val.players[i].max;
            end
        end

        -- added so i can test outside of a party\raid
        if pfx == nil then
            pfx = {["count"] = 1, ["prefix"]="party"};
        end
    elseif pfx == nil then
        grots.msg("Not in party or raid");
        return;
    end

    for raideridx=1,pfx.count do
        local raider, _, _, _, class, _, _, online = GetRaidRosterInfo(raideridx)
        local unitid = pfx.prefix..raideridx
        if raider == grots.me then
            unitid = "player";
        elseif raider == nil then
            break;
        end

        local shouldadd=false
        local drink = grots.unitHasBuff(unitid,"Drink")


        if class == "Priest" and not grots.unitHasBuff(unitid,"Shadowform") then
            shouldadd=true
        elseif class == "Paladin" and UnitPowerMax(unitid) > 4150 then
            shouldadd=true
        elseif class == "Druid" and UnitPowerMax(unitid) > 4750 then
            shouldadd=true
        end
        
        if shouldadd then
            hasHealers = true
            local c = UnitPower(unitid)
            local m = UnitPowerMax(unitid)
            table.insert(healers[class].players, {name=raider, current=c, max=m, isonline=online, isdrinking=drink})
            if (online) then
                healers[class].totalcurrent = healers[class].totalcurrent + c
                healers[class].totalmax = healers[class].totalmax + m
            end
        end
    end

    -- build the display
    if hasHealers then
        local msg = ""
        for class,val in pairs(healers) do
            if table.getn(val.players) > 0 then
                --local classheader = grots.colourTextForClass(class, class.."s - "..val.totalcurrent.." / "..val.totalmax.." ("..floor(100 * (val.totalcurrent/val.totalmax)).."\%)\r\n");
                local totalmanapercent = floor(100 * (val.totalcurrent/val.totalmax));
                local totalhealcount = string.format(" | approx %dx %ss", floor(val.totalcurrent/val.healcost), val.healname)
                local classheader = grots.colourTextForClass(class, string.format("%ss - %d / %d (%.0f%%)\r\n", class, val.totalcurrent, val.totalmax,totalmanapercent));
                msg = msg .. classheader .. string.gsub(classheader,".","-").."\r\n"
                for i in pairs(val.players) do
                    if (val.players[i].isonline) then
                        local manapercent = floor(100 * (val.players[i].current/val.players[i].max));
                        local healcount = string.format(" | ~%dx %ss", floor(val.players[i].current/val.healcost), val.healname)
                        -- msg = msg .. val.players[i].name..": "..val.players[i].current.." / "..val.players[i].max.." ("..manapercent.."\%)";
                        msg = string.format("%s%s: %s / %s (%.0f%%)%s", msg, val.players[i].name, val.players[i].current, val.players[i].max, manapercent,healcount);
                        if val.players[i].isdrinking then
                            msg = string.format("%s - %s\r\n", msg, grots.colourTextForClass("drinking", "drinking"));
                        else
                            msg = string.format("%s\r\n", msg);
                        end
                    else
                        msg = msg .. grots.colourTextForClass("offline", string.format("%s: offline\r\n", val.players[i].name));
                    end
                end
                msg = msg .. "\r\n"
            else
                msg = msg .. grots.colourTextForClass(class,string.format("%ss - None\r\n\r\n", class));
            end
        end
        grots.showEditableBox(msg)
    else
        grots.msg("Didn't find any healers")
    end

    grots.dbgmsg("Exiting grots.ListPlayers_healer()");
end

-- Raid Regrouping
function grots.SortRaid(args)
    grots.dbgmsg("Entering grots.SortRaid()");
    if grots.usercommands.sort[args[1]] ~= nil then
        grots[grots.usercommands.sort[args[1]].fn]()
    elseif args[1] ~= nil and strlen(args[1]) > 1 then
        grots.SortRaidByStr(args[1])
    else
        grots.SortRaid_cthun();
    end
    grots.dbgmsg("Exiting grots.SortRaid()");
end
function grots.SortRaid_cthun()
    grots.dbgmsg("Entering grots.SortRaid_cthun()");
    local groups = {
        {"Cathadore","Orîon","Pieinthesky","Meliara","Executey"},       -- 1 
        {"Katalis","Dunquit","Marvin","Stankybutt","Scallywagg"},       -- 2
        {"Animorpheus","Greenpaw","Sushirolls","Hotsie","Diran"},       -- 3
        {"Grimoira","Dwayne","Christalina","Ritarepulsa","Zyzz"},       -- 4
        {"Cheekshot","Balyonis","Priestly","Ambience","Turlyn"},        -- 5
        {"Beerpong","Mirlyn","Synesthesia","Dwrf","Iyzebel"},           -- 6
        {"Oneanddone","Tiesto","Zartar","Splatz","Janayaya"},           -- 7
        {"Eldind","Gilla","Myseree","Zies"}                             -- 8
    }
    local str = ""
    for grp,val in pairs(groups) do
        for i=1,table.getn(val) do
            str = string.format("%s%s:%d&",str,val[i],grp)
        end
    end
    
    grots.SortRaidByStr(str)
    grots.dbgmsg("Exiting grots.SortRaid_cthun()");
end
function grots.SortRaidByStr(str)
    grots.dbgmsg("Entering grots.SortRaidByStr()");
    if (grots.testing) then
        grots.msg(string.format("String: %s",str))
    end
    -- check if in raid
    if not IsInRaid() then
        grots.msg("Not in raid")
        return
    end
    
    -- make sure string was passed
    if not str or strlen(str) == 0 then
        grots.msg("No sorting string passed")
		return
    end
    
    -- check if the person can actually move people around
	if not UnitIsGroupLeader("player") and not UnitIsGroupAssistant("player") then
        grots.msg("You must be raid leader or promoted to sort the raid")
        return
	end

	-- Get a snapshot of the current raid layout:
	grots.UpdateRaidState()

	local wanted = {}
	-- Build a map of the desired raid layout:
	for name, group in string.gmatch(str, "([^&:]+):(%d+)") do
		-- Ignore named players not in the raid.
        if grots.options.raid.current[name] then
			wanted[name] = tonumber(group)
		end
    end

	-- Look for players not in the wanted group and move them:
    for name, group in pairs(wanted) do
        if grots.options.raid.current[name].group ~= group then
			if grots.options.raid.numInGroup[group] then
				if not grots.options.raid.numInGroup[group] or grots.options.raid.numInGroup[group] < 5 then
                    if (grots.testing) then
                        grots.msg(string.format("Moving %s to group %d with open slots",name, group))
                    end
                    -- Just move them:
                    SetRaidSubgroup(grots.options.raid.current[name].index, group)
                    grots.UpdateRaidState()
                else
                    if (grots.testing) then
                        grots.msg(string.format("Searching for someone to move %s to group %d with",name, group))
                    end
					-- Look for someone to swap with:
					for xname, xdata in pairs(grots.options.raid.current) do
                        if xdata.group == group and wanted[xname] ~= group then
                            if (grots.testing) then
                                grots.msg(string.format("Swapping %s with %s",name,GetRaidRosterInfo(xdata.index)))
                            end
							-- Do the swap:
							SwapRaidSubgroup(grots.options.raid.current[name].index, xdata.index)
							-- Update the snapshot:
                            grots.UpdateRaidState()
						end
					end
                end
            else
                if (grots.testing) then
                    grots.msg(string.format("No subgroup %d exists, moving %s",group, name ))
                end
                SetRaidSubgroup(grots.options.raid.current[name].index, group)
                grots.UpdateRaidState()
			end
        else
            if (grots.testing) then
                grots.msg(string.format("%s is already in subgroup %d",name,group))
            end
        end
    end
    grots.dbgmsg("Exiting grots.SortRaidByStr()");
end

-- Utility functions
function grots.isThrottled(t)
    local timediff = time() - t;
    return (timediff <= grots.options.throttle_s), (grots.options.throttle_s - timediff);
end
function grots.isMaster(name)
    if (name ~= nil) then
        for i = 1, table.getn(grots.options.masters) do
            if (string.find(name, grots.options.masters[i]) ~= nil) then
                return true;
            end
        end
    end
    return false;
end
function grots.dbgmsg(txt)
    if (grots.debug) then
        print(string.format("[%d]", GetTime()).." - "..txt)
    end
end
function grots.msg(txt)
    DEFAULT_CHAT_FRAME:AddMessage("|cfffff569GROTS: "..txt.."|r")
end
function grots.dump(ary)
    if (type(ary) == "table") then
        for index,value in pairs(ary) do 
            DEFAULT_CHAT_FRAME:AddMessage("DUMP TBL:"..tostring(index).." : "..tostring(value))
        end
    else
        DEFAULT_CHAT_FRAME:AddMessage("DUMP NON-TBL: "..type(ary).." : "..tostring(ary))
    end
end
function grots.aSplit(inputstr, sep)
	if sep == nil then
		sep = "%s"
    end
    if (string.find(inputstr, sep) == nil) then
        return {inputstr};
    end

	local t={}
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		if tContains(t, str)==false then
			table.insert(t, str)
		end
	end
	return t
end
function grots.showEditableBox(text)
    if not KethoEditBox then --create the frame, all this is copied from some forum
        local f = CreateFrame("Frame", "KethoEditBox", UIParent, "DialogBoxFrame")
        f:SetPoint("CENTER")
        f:SetSize(600, 500)
        
        f:SetBackdrop({
            bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
            edgeFile = "Interface\\PVPFrame\\UI-Character-PVP-Highlight", -- this one is neat
            edgeSize = 16,
            insets = { left = 8, right = 6, top = 8, bottom = 8 },
        })
        f:SetBackdropBorderColor(0, .44, .87, 0.5) -- darkblue
        
        -- Movable
        f:SetMovable(true)
        f:SetClampedToScreen(true)
        f:SetScript("OnMouseDown", function(self, button)
            if button == "LeftButton" then
                self:StartMoving()
            end
        end)
        f:SetScript("OnMouseUp", f.StopMovingOrSizing)
        
        -- ScrollFrame
        local sf = CreateFrame("ScrollFrame", "KethoEditBoxScrollFrame", KethoEditBox, "UIPanelScrollFrameTemplate")
        sf:SetPoint("LEFT", 16, 0)
        sf:SetPoint("RIGHT", -32, 0)
        sf:SetPoint("TOP", 0, -16)
        sf:SetPoint("BOTTOM", KethoEditBoxButton, "TOP", 0, 0)
        
        -- EditBox
        local eb = CreateFrame("EditBox", "KethoEditBoxEditBox", KethoEditBoxScrollFrame)
        eb:SetSize(sf:GetSize())
        eb:SetMultiLine(true)
        eb:SetAutoFocus(false) -- dont automatically focus
        eb:SetFontObject("ChatFontNormal")
        eb:SetScript("OnEscapePressed", function() f:Hide() end)
        sf:SetScrollChild(eb)
        
        -- Resizable
        f:SetResizable(true)
        f:SetMinResize(150, 100)
        
        local rb = CreateFrame("Button", "KethoEditBoxResizeButton", KethoEditBox)
        rb:SetPoint("BOTTOMRIGHT", -6, 7)
        rb:SetSize(16, 16)
        
        rb:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
        rb:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
        rb:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
        
        rb:SetScript("OnMouseDown", function(self, button)
            if button == "LeftButton" then
                f:StartSizing("BOTTOMRIGHT")
                self:GetHighlightTexture():Hide() -- more noticeable
            end
        end)
        rb:SetScript("OnMouseUp", function(self, button)
            f:StopMovingOrSizing()
            self:GetHighlightTexture():Show()
            eb:SetWidth(sf:GetWidth())
        end)
        f:Show()
    end
    
    if text then
        KethoEditBoxEditBox:SetText(text)
    end
    KethoEditBox:Show()
end
function grots.buildCommand(command,args)
    grots.dbgmsg("Entering grots.buildCommand()");
    grots.dbgmsg("Exiting grots.buildCommand()");
    return command..ADDON_MSGDELIM..args;
end
function grots.unitHasBuff(unit,buff)
    for buffidx=1,40 do
        local ubuff = UnitAura(unit,buffidx)
        if ubuff == nil then
            return false
        end
        if ubuff == buff then
            return true
        end
    end
    return false
end
function grots.colourTextForClass(class, text)
    local lclass = string.lower(class);
    if grots.options.colours[lclass] ~= nil then
        return "|cFF"..grots.options.colours[lclass].hex..text.."|r"
    else
        return text
    end
end
function grots.getRaidOrPartyPrefix()
    grots.dbgmsg("Entering grots.getRaidOrPartyPrefix()")
    if IsInRaid() then
        grots.dbgmsg("Exiting grots.getRaidOrPartyPrefix() - raid")
        return {prefix= "raid", count=GetNumGroupMembers()}
    elseif IsInGroup() then
        grots.dbgmsg("Exiting grots.getRaidOrPartyPrefix() - party")
        return {prefix="party", count=GetNumGroupMembers()}
    else
        grots.dbgmsg("Exiting grots.getRaidOrPartyPrefix() - nil")
        return nil;
    end
end
function grots.UpdateRaidState()
    if (grots.testing) then
        grots.msg("Updating Raid State")
    end
	wipe(grots.options.raid.numInGroup)
	wipe(grots.options.raid.current)
	for i = 1, GetNumGroupMembers() do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
		grots.options.raid.current[name] = { index = i, group = subgroup }
		grots.options.raid.numInGroup[subgroup] = (grots.options.raid.numInGroup[subgroup] or 0) + 1
	end
end
function grots.tableContains(t, e)
    for _, value in pairs(t) do
        if value == e then
            return true
        end
    end
    return false
end


-- Testing functions
function grots.test()
    local slots = {"HeadSlot","ShoulderSlot","BackSlot","ChestSlot","WristSlot","HandsSlot","WaistSlot","LegsSlot","FeetSlot","MainHandSlot","SecondaryHandSlot"}
    for i,v in pairs(slots) do
        local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo(v))
        if (mainHandLink ~= nil) then
            local _, link = GetItemInfo(mainHandLink);
            local _, _, _, _, Id, Enchant = string.find(link,"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
            if (grots.enchants[Enchant] ~= nil) then
                grots.msg(v.." enchant: "..grots.enchants[Enchant]);
            end
        end
    end
end

grots.EventManager:SetScript("OnEvent", grots.OnEvent);
grots.EventManager:RegisterEvent("ADDON_LOADED");
grots.EventManager:RegisterEvent("PLAYER_LOGIN");
grots.EventManager:RegisterEvent("CHAT_MSG_ADDON");
StaticPopupDialogs["GROTS_CONFIRM_SEND_MESSAGE"] = {
    text = "Would you like to announce that Stanky is the greatest rogue on the server? This will send to: %s ",
    button1 = "Yes",
    button2 = "No",
    OnAccept = function(self, data, data2)
        grots.executeAnnouncement(data);
    end,
    OnCancel = function(self, data)
        grots.msg(grots.options.slave_no[math.random(1,table.getn(grots.options.slave_no))]);
        return false;
    end,
    timeout = 10,
    whileDead = true,
    hideOnEscape = true,
    preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
  }